unit UCompilerC;

{$mode Delphi}{$H+}

interface

uses
  Classes, SysUtils, UCompiler;

type

  { TBrainFuckCompilerC }

  TBrainFuckCompilerC = class(TBrainFuckCompiler)
    constructor Create; override;
    procedure Compile; override;
  end;

implementation

{ TBrainFuckCompilerC }

constructor TBrainFuckCompilerC.Create;
begin
  inherited Create;
  Name := 'C';
  SourceExtension := '.c';
  CompiledExtension := '.exe';
  {$IFDEF Windows}
  CompilerPath := 'C:\Program Files\Dev-Cpp\mingw32-gcc.exe';
  {$ENDIF}
  {$IFDEF Linux}
  CompilerPath := '/usr/bin/gcc';
  {$ENDIF}
end;

procedure TBrainFuckCompilerC.Compile;
var
  I: Integer;
  Sum: Integer;

function CheckOccurence(C: Char): Integer;
begin
  Result := 1;
  if Optimization = coNormal then
  while ((I + 1) <= Length(Source)) and (Source[I + 1] = C) do begin
    Inc(Result);
    Inc(I)
  end;
end;

begin
  Indent := 0;
  Output := '';

  AddLine('#include <stdio.h>');
  AddLine('');
  AddLine('int main()');
  AddLine('{');
  Inc(Indent);
  AddLine('char[30000] Memory;');
  AddLine('int Pos;');
  AddLine('char ReadChar;');
  AddLine('');
  AddLine('Pos = 0;');
  I := 1;
  while (I <= Length(Source)) do begin
    case Source[I] of
      '>': begin
        Sum := CheckOccurence('>');
        AddLine('Pos = Pos + ' + IntToStr(Sum) + ';');
      end;
      '<': begin
        Sum := CheckOccurence('<');
        AddLine('Pos = Pos - ' + IntToStr(Sum) + ';');
      end;
      '+': begin
        Sum := CheckOccurence('+');
        AddLine('Memory[Pos] = Memory[Pos] + ' + IntToStr(Sum) + ';');
      end;
      '-': begin
        Sum := CheckOccurence('-');
        AddLine('Memory[Pos] = Memory[Pos] - ' + IntToStr(Sum) + ';');
      end;
      '.': AddLine('putc(Memory[Pos]);');
      ',': AddLine('getc(Memory[Pos]);');
      '[': begin
        AddLine('while(Memory[Pos] <> 0)');
        AddLine('{');
        Inc(Indent);
      end;
      ']': begin
        Dec(Indent);
        AddLine('}');
      end;
    end;
    Inc(I);
  end;
  AddLine('return 0;');
  Dec(Indent);
  AddLine('}');
end;

end.

